#!/usr/bin/env python
# -*- coding: utf-8 -*-

from setuptools import setup
import inspect
from tracrst import __author__, __version__, __license__
from tracrst.macro import TracReSTMacro

setup(
    name = 'ReST',
    version = __version__,
    packages = ['tracrst'],
    author = __author__,
    description = "ReST Wiki macro",
    long_description = inspect.getdoc(TracReSTMacro),
    license = __license__,
    keywords = "trac rst macro",
    url = "http://pythonfr.org/",
    package_data={'tracrst' : [ 'templates/*.cs']},

    entry_points = {
        'trac.plugins': [
            'tracrst.macro = tracrst.macro',
            'tracrst.editor = tracrst.editor'            
        ]
    },
)
